#include "bla.h"

extern unsigned char bla_fontdata[];

void bla_drawStr(bla_Window *w, int x, int y, int c, int b, const char *s)
{
	int i, j, k, ch, pt;
	for (i = 0; s[i] != '\0'; i++) {
		ch = s[i];
		if (ch < ' ' || ch > 0x7f) ch = ' ';
		ch = (ch - ' ') * 16;
		for (j = 0; j < 16; j++) {
			pt = bla_fontdata[ch + j];
			for (k = 0; k < 8; k++) {
				if ((pt & 0x80) != 0) {
					bla_setPix(w, x + k, y + j, c);
				} else {
					bla_setPix(w, x + k, y + j, b);
				}
				pt <<= 1;
			}
		}
		x += 8;
	}
	return;
}

