// jck1

#include "jck0.h"
#include "jcklib.h"
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

#define VARSIZ		1024
#define LABSIZ		512
#define REPSIZ		256

typedef struct Var_ {
	const unsigned char *nam;
	int cnt, tmp;
} Var;

typedef struct Rep_ {
	const unsigned char *nam, *rep;
	int len;
} Rep;

static int searchVar(Var *v, int v1, const unsigned char *nam)
{
	int i;
	for (i = v1 - 1; i >= 1; i--) {
		if (ssc(v[i].nam, nam) == 0) break;
	}
	return i;
}

int putToken(unsigned char *d, const unsigned char *s)
{
	return putJck_(d, 0, "%t ", s);
}

int putTokenEx(unsigned char *d, const unsigned char *s, Rep *r, int r1, int l, int *pcc)
{
	int i, q = 0, p = 0;
	for (i = r1 - 1; i >= 1; i--) {
		if (ssc(s, r[i].nam) == 0) break;
	}
	if (i >= 1 && r[i].len <= l) {
		s = r[i].rep;
		for (l = 0; l < r[i].len; l++) {
			q += putToken(&d[q], &s[p]);
			p = nextToken(s, p);
		}
		(*pcc)++;
	} else
		q = putToken(d, s);
	return q;
}

int jck1(const unsigned char *src, unsigned char *dst, int siz1, int *pc0, int *pc1, int *pc2, int *pcc)
// ʂŕssrcnȂƂۏႷ. Ō̓Xy[Xł. Ō ; ł(̓Rg).
{
	int ph, pc, qc, i, j, k, var1, lab1, rep1, cc = 0, pcf[8], pcfl;
	Var var[VARSIZ], lab[LABSIZ];
	Rep rep[REPSIZ];
	const unsigned char *p;
	*pc2 = 0;
	for (ph = 0; ph < 2; ph++) {
		pc = qc = 0;
		var1 = lab1 = rep1 = 1;
		if (src[pc] == ' ')
			dst[qc++] = src[pc++];
		for (;;) {
			while (src[pc] == ' ' || src[pc] == '\n' || src[pc] == '\t') pc++;
			if (src[pc] == '/' && src[pc + 1] == '/') {
				while (src[pc] != 0 && src[pc] != '\n') pc++;
				continue;
			}
			*pc0 = pc;
			if (qc + 64 >= siz1) {
				*pc1 = pc;
				return jck0_ERR_OUTPUT;	// obt@̕s.
			}
			pcf[0] = pc;
			pcfl = -1;
			for (i = 0; i < 8; i++) {
				if (i > 0) pcf[i] = nextToken(src, pcf[i - 1]);
				if (pcfl < 0 && ssc(&src[pcf[i]], "; ") == 0) pcfl = i;
			}
			if (src[pc] == 0) break;
			if (pcfl == 0) {
			} else if (mssc(&src[pc], "$option $startup $db $reserve $if $del $dev $reg ") >= 0) {	// $ifȍ~͎b[u.
through:
				for (;;) {
					if (ssc(&src[pc], "; ") == 0) break;
					while (src[pc] != ' ') {
						dst[qc++] = src[pc++];
						if (qc + 64 >= siz1) {
							*pc1 = pc;
							return jck0_ERR_OUTPUT;	// obt@̕s.
						}
					}
					dst[qc++] = src[pc++];
				}
				dst[qc++] = src[pc++];
				dst[qc++] = src[pc++];
			} else if (mssc(&src[pc], "* $return ") >= 0) {
				p = "; ";
				if (ph == 0) goto exp0;
				if (ssc(&src[pc], "* ") == 0) {
					qc += putJck_(&dst[qc], 0, "* %t ", &src[pcf[1]]);
					pc = pcf[2];
				} else {
					qc += putToken(&dst[qc], "$return ");
					pc = pcf[1];
				}
				goto throughEx1;
			} else if (ssc(&src[pc], "$label ") == 0) {
				rep1 = 1;
				goto through;
			} else if (ssc(&src[pc], "$call ") == 0) {
				rep1 = 1;
				goto through;
			} else if (ssc(&src[pcf[1]], "= ") == 0) {
				p = &src[pc];
				if (ph == 0) {
exp0:
					while (ssc(&src[pc], "; ") != 0) {
						if (mssc(&src[pc], "= + - * / % $return ") < 0 && ssc(&src[pc], p) != 0) {
							i = searchVar(var, var1, &src[pc]);
							var[i].cnt++;
						}
						pc = nextToken(src, pc);
					}
					dst[qc++] = src[pc++];
					dst[qc++] = src[pc++];
				} else {
					int qc0 = qc;
					const unsigned char *a = &src[pc], *op;
					i = searchVar(var, var1, a);
					if (i >= 1 && var[i].cnt == 0 && var[i].tmp == 1) {
						while (ssc(&src[pc], "; ") != 0)
							pc = nextToken(src, pc);
						pc = nextToken(src, pc);
						cc++;
						continue;
					}
					if (pcfl == 3 && ssc(a, &src[pcf[2]]) == 0 && i >= 1 && var[i].tmp == 1) {
						pc = pcf[pcfl + 1];
						cc++;
						continue;
					}
					if (pcfl == 4) {
						op = &src[pcf[2]];
						if (testConstInt(&src[pcf[3]]) != 0) {
							int b = getConstInt(&src[pcf[3]]);
							if (ssc(op, "- ") == 0) qc += putJck_(&dst[qc], 0, "%t = %X ; ", a, - b);
							if (ssc(op, "~ ") == 0) qc += putJck_(&dst[qc], 0, "%t = %X ; ", a, ~ b);
						}
					}
					if (pcfl == 5) {
						op = &src[pcf[3]];
						if (testConstInt(&src[pcf[2]]) != 0 && testConstInt(&src[pcf[4]]) != 0) {
							int b = getConstInt(&src[pcf[2]]), c = getConstInt(&src[pcf[4]]);
							if (ssc(op, "+ ") == 0) qc += putJck_(&dst[qc], 0, "%t = %X ; ", a, b + c);
							if (ssc(op, "- ") == 0) qc += putJck_(&dst[qc], 0, "%t = %X ; ", a, b - c);
							if (ssc(op, "* ") == 0) qc += putJck_(&dst[qc], 0, "%t = %X ; ", a, b * c);
							if (ssc(op, "/ ") == 0) qc += putJck_(&dst[qc], 0, "%t = %X ; ", a, b / c);
							if (ssc(op, "% ") == 0) qc += putJck_(&dst[qc], 0, "%t = %X ; ", a, b % c);
						} else if (testConstInt(&src[pcf[2]]) != 0) {
							int b = getConstInt(&src[pcf[2]]);
							const unsigned char *c = &src[pcf[4]];
							if (ssc(op, "+ ") == 0 && b ==  0) qc += putJck_(&dst[qc], 0, "%t = %t ; ", a, c);
							if (ssc(op, "- ") == 0 && b ==  0) qc += putJck_(&dst[qc], 0, "%t = - %t ; ", a, c);
							if (ssc(op, "* ") == 0 && b ==  0) qc += putJck_(&dst[qc], 0, "%t = 0 ; ", a);
							if (ssc(op, "* ") == 0 && b ==  1) qc += putJck_(&dst[qc], 0, "%t = %t ; ", a, c);
							if (ssc(op, "* ") == 0 && b == -1) qc += putJck_(&dst[qc], 0, "%t = - %t ; ", a, a);
						} else if (testConstInt(&src[pcf[4]]) != 0) {
							const unsigned char *b = &src[pcf[2]];
							int c = getConstInt(&src[pcf[4]]);
							if (ssc(op, "+ ") == 0 && c ==  0) qc += putJck_(&dst[qc], 0, "%t = %t ; ", a, b);
							if (ssc(op, "- ") == 0 && c ==  0) qc += putJck_(&dst[qc], 0, "%t = %t ; ", a, b);
							if (ssc(op, "* ") == 0 && c ==  0) qc += putJck_(&dst[qc], 0, "%t = 0 ; ", a);
							if (ssc(op, "* ") == 0 && c ==  1) qc += putJck_(&dst[qc], 0, "%t = %t ; ", a, b);
							if (ssc(op, "* ") == 0 && c == -1) qc += putJck_(&dst[qc], 0, "%t = - %t ; ", a, a);
							if (ssc(op, "/ ") == 0 && c ==  1) qc += putJck_(&dst[qc], 0, "%t = %t ; ", a, b);
							if (ssc(op, "/ ") == 0 && c == -1) qc += putJck_(&dst[qc], 0, "%t = - %t ; ", a, b);
							if (ssc(op, "% ") == 0 && c ==  1) qc += putJck_(&dst[qc], 0, "%t = 0 ; ", a);
						}
					}
					if (qc > qc0) {
						pc = pcf[pcfl + 1];
						cc++;
						continue;
					}
					if (i >= 1 && var[i].tmp == 1 && ssc(&src[pcf[2]], "$#int32 ") != 0) {
						// tmpłrepɓo^(łEӂ$#int32̏ꍇ͓o^Ȃ).
						rep[rep1].nam = &src[pc];
						rep[rep1].rep = &src[pcf[2]];
						rep[rep1].len = pcfl - 2;
						rep1++;
						// ȎQƂ΁Alen=9ɂĂ܂.
						// ɉߋ̂̂łA&src[pc]܂ނׂ̂͂9ɂ.
						for (i = 1; i < rep1; i++) {
							if (rep[i].len > 3) continue;
							k = 0;
							for (j = 0; j < rep[i].len; j++) {
								if (ssc(&(rep[i].rep[k]), &src[pc]) == 0) {
									rep[i].len = 9;
									break;
								}
								k = nextToken(rep[i].rep, k);
							}
						}
					}
					qc += putJck_(&dst[qc], 0, "%t = ", &src[pc]);
					pc = pcf[2];
//throughEx:
					i = nextToken(src, pc);
					if (ssc(&src[i], "; ") == 0) {
						qc += putTokenEx(&dst[qc], &src[pc], rep, rep1, 3, &cc);
						pc = nextToken(src, pc);
						qc += putToken(&dst[qc], "; ");
						pc = nextToken(src, pc);
						continue;
					}
throughEx1:
					while (ssc(&src[pc], "; ") != 0) {
						qc += putTokenEx(&dst[qc], &src[pc], rep, rep1, 1, &cc);
						pc = nextToken(src, pc);
					}
					qc += putToken(&dst[qc], "; ");
					pc = nextToken(src, pc);
				}
			} else if (mssc(&src[pc], "$local $temp ") >= 0) {
				if (ph == 0) {
					i = 2;
					if (ssc(&src[pc], "$temp ") == 0)
						i = 1;
					pc = nextToken(src, pc);
					pc = nextToken(src, pc);
					while (ssc(&src[pc], "; ") != 0) {
						if (var1 >= VARSIZ) {
							*pc1 = pc;
							return jck0_ERR_OVRDEF;	// ϐ̓o^I[o[.
						}
						var[var1].nam = &src[pc];
						var[var1].tmp = i;
						var[var1].cnt = 0;
						var1++;
						pc = nextToken(src, pc);
					}
					pc = nextToken(src, pc);
				} else {
					k = ssc(&src[pc], "$temp ");
					i = qc;
					j = 0;
					qc += putToken(&dst[qc], &src[pc]);
					pc = nextToken(src, pc);
					qc += putToken(&dst[qc], &src[pc]);
					pc = nextToken(src, pc);
					while (ssc(&src[pc], "; ") != 0) {
						var[var1].nam = &src[pc];
						if (k != 0 || var[var1].cnt > 0) {
							qc += putToken(&dst[qc], &src[pc]);
							j++;
						} else
							cc++;
						var1++;
						pc = nextToken(src, pc);
					}
					qc += putToken(&dst[qc], &src[pc]);
					pc = nextToken(src, pc);
					if (j == 0)
						qc = i;
				}
			} else {
				*pc1 = pc;
				return jck0_ERR_SYNTAX;
			}
		}
	}
	*pcc = cc;
	dst[qc] = 0;
	return qc;
}
