#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <stdarg.h>
#include <string.h>
#include "jck0.h"
//#include "bla.h"

void loadText(int argc, const char **argv, unsigned char *t, int siz)
{
	FILE *fp;
	int i;
	if (argc < 2) {	// Ȃ̂ŃG[\ďI.
		printf("usage>%s aource-file\n", argv[0]);
		exit(1);
	}
	fp = fopen(argv[1], "rb");	// oCi[hŃt@CJ
	if (fp == 0) {	// t@CJȂ.
		printf("fopen error : %s\n", argv[1]);
		exit(1);
	}
	i = fread(t, 1, siz - 1, fp);
	fclose(fp);
	t[i] = 0;	// I[}[NĂ.
}

int lexer(unsigned char *s, unsigned char *b, int siz1, int *pc)		// vOPig[Njɐ؂蕪.
{
	int i, j;
	char ctyp[256];
	for (i = 0; i < 256; i++) {
		j = 0;
		if (i == ' ' || i == '\t' || i == '\n' || i == '\r') j = 1;	// Xy[XA^uAs.
		if ('0' <= i && i <= '9') j = 2;	// .
		if ('a' <= i && i <= 'z') j = 2;	// ϐ̈ꕶڂɎg镶.
		if ('A' <= i && i <= 'Z') j = 2;
		if (i == '_') j = 2;
		if (i >= 0x80) j = 2;	// {vO~Ỏ (by K, 2018.07.21).
		if (strchr("=+-*/!%&~|<>?:.", i) != 0) j = 3;	// ʂ̋L.
		if (strchr("(){}[];,", i) != 0) j = 4;	// 1ō\L.
		ctyp[i] = j;
	}
	i = j = 0;
	b[j++] = ' ';

	for (;;) {
		if (ctyp[s[i]] == 1) {	
			i++;
			continue;
		}
		if (s[i] == '/' && s[i + 1] == '/') {
			while (s[i] != 0 && s[i] != '\n')
				i++;
			continue;
		}
		if (s[i] == '`') {
			while (s[i] != 0 && ctyp[s[i]] != 1)
				i++;
			continue;
		}
		if (j >= siz1) return -1;
		if (pc != 0)
			pc[j] = i;
		if (s[i] == 0)	// t@CI[.
			break;
		if (ctyp[s[i]] == 4) {	// 1L.
			b[j++] = s[i++];
		} else if (ctyp[s[i]] == 2) {  // 1ڂp.
			while (ctyp[s[i]] == 2 && j < siz1)
				b[j++] = s[i++];
		} else if (ctyp[s[i]] == 3) {  // 1ڂʂ̋L.
			while (ctyp[s[i]] == 3 && j < siz1)
				b[j++] = s[i++];
		} else {
			printf("lexer: syntax error : %.10s\n", &s[i]);
			exit(1);
		}
		if (j >= siz1) return -1;
		b[j++] = ' '; // P̏I[}[N.
	}
	b[j] = 0;
	return j;
}
