#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef unsigned char *String;	// String  unsigned char * ̑pɂȂ.

void loadText(int argc, const char **argv, String t, int siz)
{
	FILE *fp;
	int i;
	if (argc < 2) {  // Ȃ̂ŃG[\ďI.
		printf("usage>%s program-file\n", argv[0]);
		exit(1);
	}
	fp = fopen(argv[1], "rt"); // eLXg[hŃt@CJ.
	if (fp == 0) {  // t@CJȂ.
		printf("fopen error : %s\n", argv[1]);
		exit(1);
	}
	i = fread(t, 1, siz - 1, fp);
	fclose(fp);
	t[i] = 0; // I[}[NĂ.
}

int isNumber(unsigned char c)	// ǂ.
{
	if ('0' <= c && c <= '9') return 1;
	return 0;
}

int isAlphabet(unsigned char c)		// ϐ̈ꕶڂɎg镶ǂ.
{
	if ('a' <= c && c <= 'z') return 1;
	if ('A' <= c && c <= 'Z') return 1;
	if (c == '_') return 1;
	return 0;
}

int isSymbol(unsigned char c)	// ʂ̋L.
{
	if (strchr("=+-*/!%&~|<>?:.", c) != 0) return 1;
	return 0;
}

int lexer(String s, String b, String t[])		// vOPig[Njɐ؂蕪.
{
	int i = 0, j = 0, k = 0;
	for (;;) {
		if (s[i] == ' ' || s[i] == '\t' || s[i] == '\n') {	// Xy[XA^uAs.
			i++;
			continue;
		}
		t[k++] = &b[j];	// P̐擪o^.
		if (s[i] == 0)	// t@CI[.
			return k;
        if (strchr("(){}[];,", s[i]) != 0) {	// 1L.
			b[j++] = s[i++];
		} else if (isNumber(s[i]) != 0) {  // 1ڂ.
			while (isNumber(s[i]) != 0)
				b[j++] = s[i++];
		} else if (isAlphabet(s[i]) != 0) {  // 1ڂp.
			while (isAlphabet(s[i]) != 0 || isNumber(s[i]) != 0)
				b[j++] = s[i++];
		} else if (isSymbol(s[i]) != 0) {  // 1ڂʂ̋L.
			while (isSymbol(s[i]) != 0)
				b[j++] = s[i++];
		} else {
			printf("syntax error : %.10s\n", &s[i]);
			exit(1);
		}
		b[j++] = 0; // P̏I[}[N.
	}
}

int var[256];	// ϐ.
String varName[256];	// ϐ.
unsigned char txt[10000]; // \[XR[h.
int pc = 0;	// vOJE^.

int varNumber(String t)		// ϐϐԍ𓾂.
{
	int i;
	for (i = 0; varName[i] != 0; i++) {
		if (strcmp(t, varName[i]) == 0)
			return i;
	}
	varName[i] = t;
	return i;
}

int getNumber(String t)
{
	if (isNumber(t[0]) == 0)	// 1ڂȊO.
		return var[varNumber(t)];
	return strtol(t, 0, 0);	// t𐔒lɕϊ.
}

int main(int argc, const char **argv)
{
	int i, pc0;
	unsigned char buf[10000];
	String t[1000];	// g[N.
	loadText(argc, argv, txt, 10000);
	i = lexer(txt, buf, t);
	t[i + 0] = t[i + 1] = t[i + 2] = t[i + 3] = "";	// G[\p̂߂ɖɂ0̕o^Ă.
    for (;;) {
		pc0 = pc;
        if (strcmp(t[pc], "") == 0)		// t@CI[.
			exit(0);
		if (isAlphabet(t[pc][0]) != 0 && strcmp(t[pc + 1], "=") == 0) { // 1PڂAt@xbgŎn܂āA2Pڂ"=".
			i = varNumber(t[pc]);
			if (strcmp(t[pc + 3], ";") == 0) { // P.
				var[i] = getNumber(t[pc + 2]);
            } else if (strcmp(t[pc + 3], "+") == 0 && strcmp(t[pc + 5], ";") == 0) {  // Z.
				var[i] = getNumber(t[pc + 2]) + getNumber(t[pc + 4]);
			} else if (strcmp(t[pc + 3], "-") == 0 && strcmp(t[pc + 5], ";") == 0) {  // Z.
				var[i] = getNumber(t[pc + 2]) - getNumber(t[pc + 4]);
			} else
				goto err;
        } else if (strcmp(t[pc], "print") == 0 && strcmp(t[pc + 2], ";") == 0) { // print.
            printf("%d\n", getNumber(t[pc + 1]));
        } else
			goto err;
		while (strcmp(t[pc], ";") != 0)
			pc++;
		pc++;
    }
err:
    printf("syntax error : %s %s %s %s\n", t[pc0], t[pc0 + 1], t[pc0 + 2], t[pc0 + 3]);
    exit(1);
}
