#include "bla_easy.h"

int main()
{
	int high = 0, score, bx, by, vx, vy, i, j, k, mx, my, ml;
	char c[40][30], d, s[80];
	Window *win = openWin(640, 480, "a ball");
	for (;;) {
		fillRect(win, 640, 480, 0, 0, 0);
		bx = 19; by = 20; vx = 1; vy = -1;
		mx = 15; my = 29; ml = 10;
		for (i = 0; i < 40; i++) {
			for (j = 0; j < 30; j++)
				c[i][j] = 0;
		}
		for (i = 0; i < 40; i++)
			c[i][1] = 1;
		fillRect(win, 640, 16, 0, 16, 0xffffff);
		for (j = 2; j < 30; j++)
			c[0][j] = c[39][j] = 1;
		fillRect(win, 16, 448,   0, 32, 0xffffff);
		fillRect(win, 16, 448, 624, 32, 0xffffff);
		score = 0;
		for (;;) {

			fillRect(win, 640, 16, 0, 0, 0x000000);
			sprintf(s, "SCORE:%05d     HIGH:%05d", score, high);
			drawStr(win, 160, 0, 0xffffff, 0x000000, s);

			// ball
			fillRect(win, 16, 16, bx * 16, by * 16, 0);
			c[bx][by] = 0;
			i = score / 100;
			if (c[bx + vx][by] == 2 || c[bx][by + vy] == 2 || c[bx + vx][by + vy] == 2) {
				score += 29 - by;
				if (high < score) high = score;
			}
			if (c[bx + vx][by] != 0) vx *= -1;
			if (c[bx][by + vy] != 0) vy *= -1;
			if (c[bx + vx][by + vy] != 0) { vx *= -1; vy *= -1; }
			if (c[bx + vx][by + vy] == 0) {
				bx += vx;
				by += vy;
			}
			fillOval(win, 16, 16, bx * 16, by * 16, 0xffffff);
			c[bx][by] = 1;
			if (by >= 29) break;
			if (score / 100 != i && ml > 4) {
				fillRect(win, ml * 16, 16, mx * 16, my * 16, 0);
				for (i = 0; i < ml; i++)
					c[mx + i][my] = 0;
				ml -= 1;
			}

			// pad
			fillRect(win, ml * 16, 16, mx * 16, my * 16, 0);
			for (i = 0; i < ml; i++)
				c[mx + i][my] = 0;
			j = k = 0;
			i = inkey(win) & ~KEY_LOCKS;	// Lockn̏Ԃ͖.
			if (i == KEY_LEFT)  j = -1;
			if (i == KEY_RIGHT) j = +1;
			if (i == KEY_UP)    k = -1;
			if (i == KEY_DOWN && my <= 28)  k = +1;
			if (i != 0) {
				while ((inkey0(win) & ~KEY_LOCKS) == i)
					inkey(win);
			} 
			d = 0;
			for (i = 0; i < ml; i++)
				d += c[mx + j + i][my + k];
			if (d == 0) {
				mx += j;
				my += k;
			}
			fillRect(win, ml * 16, 16, mx * 16, my * 16, 0xffffff);
			for (i = 0; i < ml; i++)
				c[mx + i][my] = 2;

			flushAll(win);
			waitEx(100);
		}
		flushAll(win);
		while ((inkey(win) & ~KEY_LOCKS) != KEY_ENTER)
			waitEx(100);
	}
	end();
}

