#include "bla.h"

void bla_setPixEx(bla_Window *w, int x, int y, int c)
{
	if (c >= 0 && 0 <= x && x < w->xsiz && 0 <= y && y < w->ysiz) {
		if (w->mode == bla_MODE_SET) w->buf[y * w->xsiz + x] =  c;
		if (w->mode == bla_MODE_OR)  w->buf[y * w->xsiz + x] |= c;
		if (w->mode == bla_MODE_AND) w->buf[y * w->xsiz + x] &= c;
		if (w->mode == bla_MODE_XOR) w->buf[y * w->xsiz + x] ^= c;
	}
	return;
}

