#include "bla.h"

#define bla_TABLESIZ	16

extern bla_Window *bla_table_w[bla_TABLESIZ];

void bla_waitEx(int msec)
{
	do {
		int i, j = 0;
		for (i = 0; i < bla_TABLESIZ; i++) {
			bla_Window *w = bla_table_w[i];
			if (w == 0) continue;
			if (w->phase == 1) j++;
		}
		if (j == 0) bla_end();
		if (msec > 0) {
			i = msec;
			if (i >= 256)
				i = 128;
			bla_wait(i);
			msec -= i;
		}
	} while (msec > 0);
	return;
}

