#include "jcklib.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

// jck0Cu邽߂̎xCułāAg߂̎xCuł͂Ȃ̂ŁAjck0.hɊ܂܂ĂȂ.

int ssc(const unsigned char *s, const unsigned char *t)
{
	const unsigned char *u = strchr(t, ' ');
	if (u == 0) return 1;
	return strncmp(s, t, u - t + 1);
}

int mssc(const unsigned char *s, const unsigned char *t)
{
	int i;
	for (i = 0; ; i++) {
		const unsigned char *u = strchr(t, ' ');
		if (u == 0) return -1;
		if (strncmp(s, t, u - t + 1) == 0) return i;
		t = u + 1;
	}
}

int nextToken(const unsigned char *s, int i)
{
	if (s[i] != 0) {
		do {
			i++;
		} while (s[i] != ' ' && s[i] != 0);
		if (s[i] == ' ') i++;
	}
	return i;
}

int testConstInt(const unsigned char *s)
{
	if ('0' <= s[0] && s[0] <= '9') return 1;
	if (s[0] == '+' && '0' <= s[1] && s[1] <= '9') return 1;
	if (s[0] == '-' && '0' <= s[1] && s[1] <= '9') return 1;
	return 0;
}

int getConstInt(const unsigned char *s)
{
	return strtol(s, 0, 0);
}

int testPhrase(const unsigned char *s, int i, unsigned char sc, const unsigned char *t, int *pi)
{
	int j = 0, k = 1, nest;
	while (t[j] > ' ') {
		if (t[j] == sc && t[j + 1] == sc && t[j + 2] == ' ') {	// @@
			pi[k++] = i;
			nest = 0;
			for (;;) {
				if (s[i] == 0) break;
				if (nest == 0 && mssc(&s[i], ", ; ) ] } ") >= 0) break;
				if (mssc(&s[i], "( [ { ") >= 0) nest++;
				if (mssc(&s[i], ") ] } ") >= 0) nest--;
				i = nextToken(s,  i);
			}
		} else if (t[j] == sc && t[j + 1] == ' ') {	// @
			pi[k++] = i;
			i = nextToken(s,  i);
		} else if (ssc(&s[i], &t[j]) == 0)
			i = nextToken(s,  i);
		else
			return 0;
		j = nextToken(t,  j);
	}
	pi[0] = i;
	return j;
}

int putJck_sub0(void **sw, unsigned char *d, const char *f, int *pi, va_list *pap)
{
	int i = *pi;
	(void) sw;
	(void) d;
	(void) pap;
	fprintf(stderr, "putJck_: unknown format '%%%c'\n", f[i + 1]);
	exit(1);
}

int vPutJck_(unsigned char *d, void **sw, const char *f, va_list ap)
{
	int i = 0, j = 0, k;
	const unsigned char *t;
	while (f[i] != 0) {
		if (f[i] != '%')
			d[j++] = f[i++];
		else if (f[i + 1] == '%') {
			i += 2;
			d[j++] = '%';
		} else if (f[i + 1] == 't') {
			i += 2;
			t = va_arg(ap, const unsigned char *);
			for (k = 0; t[k] != ' '; k++)
				d[j++] = t[k];
		} else if (f[i + 1] == 'd') {
			i += 2;
			k = va_arg(ap, int);
			j += sprintf(&d[j], "%d", k);
		} else if (f[i + 1] == 'x') {
			i += 2;
			k = va_arg(ap, int);
			j += sprintf(&d[j], "%x", k);
		} else if (f[i + 1] == 'X') {
			i += 2;
			k = va_arg(ap, int);
			if (k >= 0)
				j += sprintf(&d[j], "0x%x", k);
			else
				j += sprintf(&d[j], "-0x%x", - k);
		} else {
			void *sw0[1];
			if (sw == 0) {
				sw = sw0;
				sw0[0] = putJck_sub0;
			}
			j += ((PutJck_Sub) sw[0])(sw, &d[j], f, &i, &ap);
		}
	}
	return j;
}

int putJck_(unsigned char *d, void **sw, const char *f, ...)
{
	int i;
	va_list ap;
	va_start(ap, f);
	i = vPutJck_(d, sw, f, ap);
	va_end(ap);
	return i;
}
